// Empfangen von Zeichen über COM-Port/USB
// Ausgabe dieser Zeichen auf dem LC-Display
// Autor: Niels Nikolaisen www.elektronik.nmp24.de

#include <LiquidCrystal.h>
// Festlegen der Pins für das LCD:
LiquidCrystal lcd(12, 11, 5, 4, 3, 2);

int SignCounter = 0;

void setup() {
  // LCD starten
  lcd.begin(16, 2);
  Serial.begin(9600);

  // Ausgabe von Text in Zeile 1 und 2
  lcd.setCursor(0, 0); // 1. Zeichen, 1. Zeile
  lcd.print("Warte auf Verbin");
  lcd.setCursor(0, 1); // 1. Zeichen, 2. Zeile
  lcd.print("dungsaufbau...");
  while (Serial.available() == 0) {
    // Einfach warten!
  }
  // Sobald das erste zeichen vom PC ankommt:
  byte ASCII_Value = Serial.read();
  lcd.clear();
  lcd.setCursor(0, 1); // 1. Zeichen, 2. Zeile
  lcd.print("Verbunden mit PC");

}

void loop() {
  // Warten auf weitere Zeichen vom PC
  while (Serial.available() > 0) {
    byte ASCII_Value = Serial.read();
    lcd.clear();
    SignCounter++;
    // Ausgabe des ASCII-Wertes des empfangenen Zeichens
    // sowie des Zeichens selbst
    lcd.setCursor(0, 0); // 1. Zeichen, 1. Zeile
    lcd.print("ASCII=         ");
    lcd.setCursor(7, 0); // 1. Zeichen, 1. Zeile
    lcd.print(ASCII_Value);
    // Umwandeln von int/ASCII in char:
    char cReceived = char(ASCII_Value);
    lcd.print(" CHAR=    ");
    lcd.setCursor(15, 0); // 15. Zeichen, 1. Zeile
    lcd.print(cReceived);
    // Ausgabe der Anzahl der bisher empfangenen Zeichen
    lcd.setCursor(0, 1); // 1. Zeichen, 2. Zeile
    lcd.print("Anzahl=         ");
    lcd.setCursor(8, 1); // 1. Zeichen, 2. Zeile
    lcd.print(SignCounter);
    // Senden des empfangenen Zeichens zurück an den PC
    Serial.write(cReceived);
  }
}

